'use strict';

// https://github.com/ipfs/js-ipfs/tree/ipfs%400.55.4/docs/core-api
const IPFS = require('ipfs');

async function initialize() {
    const node = await IPFS.create();
    const node_info = await node.id();
    console.log('ipfs node id: ' + node_info.id);
    const pin = await node.add(
        'webpacked ' + node_info.agentVersion
        + ' ' + node_info.id
        + ' at ' + (new Date()).toISOString()
    );
    console.log("https://ipfs.io/ipfs/" + pin.cid.toString());
    const pin_list = document.createElement('ul');
    for await(const { cid, type } of node.pin.ls()) {
        const item = document.createElement('li');
        const link = document.createElement('a');
        link.href = "https://dweb.link/ipfs/" + cid.toString();
        link.innerText = cid.toString();
        item.appendChild(link);
        const unpin_button = document.createElement('button');
        unpin_button.innerText = 'unpin';
        unpin_button.onclick = async function() {
            await node.pin.rm(cid);
            unpin_button.remove();
        };
        item.appendChild(unpin_button);
        pin_list.appendChild(item);
    }
    document.body.appendChild(pin_list);
}

initialize();
